var SESSION_STATUS = Flashphoner.constants.SESSION_STATUS;
var STREAM_STATUS = Flashphoner.constants.STREAM_STATUS;

function init_page() {
    //init api
    try {
        Flashphoner.init({flashMediaProviderSwfLocation: '../../../../media-provider.swf'});
    } catch(e) {
        $("#notifyFlash").text("Your browser doesn't support Flash or WebRTC technology necessary for work of an example");
        return;
    }

    $("#url").val(setURL());
    onDisconnected();
    onStopped();
}

function connect() {
    var url = $('#url').val();
    //create session
    console.log("Create new session with url " + url);
    Flashphoner.createSession({urlServer: url}).on(SESSION_STATUS.ESTABLISHED, function(session){
        setStatus("#connectStatus", session.status());
        onConnected(session)
    }).on(SESSION_STATUS.DISCONNECTED, function(){
        setStatus("#connectStatus", SESSION_STATUS.DISCONNECTED);
        onDisconnected();
    }).on(SESSION_STATUS.FAILED, function(){
        setStatus("#connectStatus", SESSION_STATUS.FAILED);
        onDisconnected();
    });
}

function onConnected(session) {
    $("#connectBtn").text("Disconnect").off('click').click(function(){
        $(this).prop('disabled', true);
        session.disconnect();
    }).prop('disabled', false);
    onStopped();
}

function onDisconnected() {
    $("#connectBtn").text("Connect").off('click').click(function(){
        if (validateForm("connectionForm")) {
            $('#url').prop('disabled', true);
            $(this).prop('disabled', true);
            connect();
        }
    }).prop('disabled', false);
    $('#url').prop('disabled', false);
    onStopped();
}

function playStream() {
    var session = Flashphoner.getSessions()[0];
    var streamName = $('#streamName').val();
    var display = document.getElementById("player1");
    session.createStream({
        name: streamName,
        display: display
    }).on(STREAM_STATUS.PLAYING, function(stream) {
        document.getElementById(stream.id()).addEventListener('resize', function(event){
            resizeVideo(event.target);
        });
        setStatus("#status", stream.status());
        onPlaying(stream);
    }).on(STREAM_STATUS.STOPPED, function() {
        setStatus("#status", STREAM_STATUS.STOPPED);
        onStopped();
    }).on(STREAM_STATUS.FAILED, function() {
        setStatus("#status", STREAM_STATUS.FAILED);
        onStopped();
    }).play();
}

function onPlaying(stream) {
    $("#playBtn").text("Stop").off('click').click(function(){
        $(this).prop('disabled', true);
        stream.stop();
    }).prop('disabled', false);
    $("#switchDisplay").prop('disabled', false);
    $("#switchDisplay").off('click').click(function(){
        var videoElement = document.getElementsByTagName("video")[0];
        
        var currentPlayerId = videoElement.parentElement.id;
        var newPlayerId;
        if (currentPlayerId == "player1")
            newPlayerId = "player2";
        else 
            newPlayerId = "player1";
        
        //videoElement.pause();
        document.getElementById(currentPlayerId).removeChild(videoElement);
        document.getElementById(newPlayerId).appendChild(videoElement);
        videoElement.play();
    });
}

function onStopped() {
    $("#playBtn").text("Play").off('click').click(function(){
        if (validateForm("form")) {
            $('#streamName').prop('disabled', true);
            $(this).prop('disabled', true);
            playStream();
        }
    });
    $("#switchDisplay").prop('disabled', true);
    if (Flashphoner.getSessions()[0] && Flashphoner.getSessions()[0].status() == SESSION_STATUS.ESTABLISHED) {
        $("#playBtn").prop('disabled', false);
        $('#streamName').prop('disabled', false);
    } else {
        $("#playBtn").prop('disabled', true);
        $('#streamName').prop('disabled', true);
    }
}

//show connection or remote stream status
function setStatus(selector, status) {
    var statusField = $(selector);
    statusField.text(status).removeClass();
    if (status == "PLAYING" || status == "ESTABLISHED") {
        statusField.attr("class","text-success");
    } else if (status == "DISCONNECTED" || status == "STOPPED") {
        statusField.attr("class","text-muted");
    } else if (status == "FAILED") {
        statusField.attr("class","text-danger");
    }
}

function validateForm(formId) {
    var valid = true;
    $('#' + formId + ' :text').each(function(){
        if (!$(this).val()) {
            highlightInput($(this));
            valid = false;
        } else {
            removeHighlight($(this));
        }
    });
    return valid;

    function highlightInput(input) {
        input.closest('.input-group').addClass("has-error");
    }
    function removeHighlight(input) {
        input.closest('.input-group').removeClass("has-error");
    }
}
